## waylib 0.2.0

=== examples/blur/CMakeLists.txt ===
find_package(Qt6 COMPONENTS Quick QuickControls2 REQUIRED)
qt_standard_project_setup(REQUIRES 6.4)

if(QT_KNOWN_POLICY_QTP0001) # this policy was introduced in Qt 6.5
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()
if(POLICY CMP0071)
    # https://cmake.org/cmake/help/latest/policy/CMP0071.html
    cmake_policy(SET CMP0071 NEW)
endif()

set(QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/src/server;${QML_IMPORT_PATH}" CACHE STRING "For LSP" FORCE)

find_package(PkgConfig REQUIRED)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)

add_executable(blur
    main.cpp
)

qt_add_qml_module(blur
    URI Blur
    VERSION "1.0"
    QML_FILES
        Main.qml
    SOURCES
        helper.h
)

target_compile_definitions(blur
    PRIVATE
    SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
    $<$<BOOL:${START_DEMO}>:START_DEMO>
    WLR_USE_UNSTABLE
)

target_link_libraries(blur
    PRIVATE
    Qt6::Quick
    Qt6::QuickControls2
    waylibserver
    PkgConfig::PIXMAN
    PkgConfig::WAYLAND
)

if (INSTALL_TINYWL)
    install(TARGETS blur DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/tinywl/CMakeLists.txt ===
find_package(Qt6 COMPONENTS Quick QuickControls2 REQUIRED)
qt_standard_project_setup(REQUIRES 6.4)

if(QT_KNOWN_POLICY_QTP0001) # this policy was introduced in Qt 6.5
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()
if(POLICY CMP0071)
    # https://cmake.org/cmake/help/latest/policy/CMP0071.html
    cmake_policy(SET CMP0071 NEW)
endif()

set(QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/src/server;${QML_IMPORT_PATH}" CACHE STRING "For LSP" FORCE)
option(START_DEMO "Start demo when boot" ON)

find_package(PkgConfig REQUIRED)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)

add_executable(tinywl-qtquick
    main.cpp
)

set_source_files_properties(QmlHelper.qml
    PROPERTIES
        QT_QML_SINGLETON_TYPE TRUE
)

qt_add_qml_module(tinywl-qtquick
    URI Tinywl
    VERSION "1.0"
    SOURCES
        helper.h
    QML_FILES
        Main.qml
        StackWorkspace.qml
        XdgSurface.qml
        LayerSurface.qml
        TiledWorkspace.qml
        QmlHelper.qml
        OutputDelegate.qml
        StackToplevelHelper.qml
        TiledToplevelHelper.qml
        WindowDecoration.qml
        CloseAnimation.qml
        MiniDock.qml
        InputPopupSurface.qml
)

target_compile_definitions(tinywl-qtquick
    PRIVATE
    PROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
    $<$<BOOL:${START_DEMO}>:START_DEMO>
    WLR_USE_UNSTABLE
)

target_link_libraries(tinywl-qtquick
    PRIVATE
    Qt6::Quick
    Qt6::QuickControls2
    Waylib::WaylibServer
    PkgConfig::PIXMAN
    PkgConfig::WAYLAND
)

if (INSTALL_TINYWL)
    install(TARGETS tinywl-qtquick DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== src/server/CMakeLists.txt ===
set(TARGET waylibserver)

set(WAYLIB_CMAKE_INSTALL_DIR
    "${CMAKE_INSTALL_LIBDIR}/cmake/WaylibServer"
    CACHE STRING "Install directory for waylib cmake files"
)
set(WAYLIB_INCLUDE_INSTALL_DIR
    "${CMAKE_INSTALL_INCLUDEDIR}/${TARGET}"
    CACHE STRING "Install directory for waylib headers"
)

set(QT_COMPONENTS Core Gui Quick)
find_package(Qt6 COMPONENTS ${QT_COMPONENTS} REQUIRED)

qt_standard_project_setup(REQUIRES 6.6)

if(QT_KNOWN_POLICY_QTP0001) # this policy was introduced in Qt 6.5
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()

find_package(PkgConfig REQUIRED)
pkg_search_module(LIBDRM REQUIRED IMPORTED_TARGET libdrm)
pkg_search_module(WLROOTS REQUIRED IMPORTED_TARGET wlroots)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)
pkg_search_module(WAYLAND_PROTOCOLS REQUIRED IMPORTED_TARGET wayland-protocols)
pkg_search_module(WLR_PROTOCOLS REQUIRED wlr-protocols)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(XKBCOMMON REQUIRED IMPORTED_TARGET xkbcommon)
pkg_search_module(XCB REQUIRED IMPORTED_TARGET xcb)
pkg_search_module(EGL REQUIRED IMPORTED_TARGET egl)

ws_generate(
    server
    wayland-protocols
    unstable/text-input/text-input-unstable-v1.xml
    text-input-unstable-v1-protocol
)

ws_generate(
    server
    wayland-protocols
    ${CMAKE_CURRENT_LIST_DIR}/protocols/private/text-input-unstable-v2.xml
    text-input-unstable-v2-protocol
)

ws_generate(
    server
    wayland-protocols
    unstable/xdg-output/xdg-output-unstable-v1.xml
    xdg-output-unstable-v1-protocol
)

set(SOURCES
    kernel/wbackend.cpp
    kernel/wcursor.cpp
    kernel/winputdevice.cpp
    kernel/woutput.cpp
    kernel/wseat.cpp
    kernel/wevent.cpp
    kernel/wserver.cpp
    kernel/wsurface.cpp
    kernel/wtoplevelsurface.cpp

    kernel/wtexture.cpp
    kernel/wtypes.cpp

    kernel/woutputlayout.cpp
    kernel/wxcursorimage.cpp
    kernel/wglobal.cpp
    kernel/wsocket.cpp

    qtquick/wsurfaceitem.cpp
    qtquick/woutputhelper.cpp
    qtquick/woutputrenderwindow.cpp
    qtquick/woutputviewport.cpp
    qtquick/woutputitem.cpp
    qtquick/woutputlayoutitem.cpp
    qtquick/wquickoutputlayout.cpp
    qtquick/wquickcursor.cpp
    qtquick/wquickobserver.cpp
    qtquick/weventjunkman.cpp
    qtquick/wrenderhelper.cpp
    qtquick/wquicktextureproxy.cpp
    qtquick/woutputlayer.cpp
    qtquick/wrenderbufferblitter.cpp
    qtquick/wxdgsurfaceitem.cpp
    qtquick/wlayersurfaceitem.cpp
    qtquick/wxwaylandsurfaceitem.cpp
    qtquick/wqmlcreator.cpp
    qtquick/winputpopupsurfaceitem.cpp

    qtquick/private/wquickcoordmapper.cpp
    qtquick/private/wquicksocketattached.cpp
    qtquick/private/wqmlhelper.cpp
    qtquick/private/wbufferrenderer.cpp
    qtquick/private/wrenderbuffernode.cpp

    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/text-input-unstable-v1-protocol.c
    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/text-input-unstable-v2-protocol.c
    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/xdg-output-unstable-v1-protocol.c

    utils/wtools.cpp
    utils/wthreadutils.cpp
    utils/wimagebuffer.cpp
    utils/wcursorimage.cpp

    platformplugin/qwlrootsintegration.cpp
    platformplugin/qwlrootscreen.cpp
    platformplugin/qwlrootswindow.cpp
    platformplugin/qwlrootscursor.cpp
    platformplugin/types.cpp

    protocols/wxdgshell.cpp
    protocols/wxdgsurface.cpp
    protocols/wxwayland.cpp
    protocols/wxwaylandsurface.cpp
    protocols/wlayersurface.cpp
    protocols/wforeigntoplevelv1.cpp
    protocols/wxdgoutput.cpp
    protocols/wxdgdecorationmanager.cpp
    protocols/wlayershell.cpp
    protocols/winputmethodhelper.cpp
    protocols/winputpopupsurface.cpp
    protocols/private/winputmethodv2.cpp
    protocols/private/wtextinputv1.cpp
    protocols/private/wtextinputv2.cpp
    protocols/private/wtextinputv3.cpp
    protocols/private/wvirtualkeyboardv1.cpp
    protocols/wcursorshapemanagerv1.cpp
    protocols/woutputmanagerv1.cpp

    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/text-input-unstable-v1-protocol.c
)

set(HEADERS
    kernel/wglobal.h
    kernel/wbackend.h
    kernel/wcursor.h
    kernel/winputdevice.h
    kernel/woutput.h
    kernel/wseat.h
    kernel/wevent.h
    kernel/wserver.h
    kernel/wsurface.h
    kernel/wtexture.h
    kernel/wtypes.h
    kernel/woutputlayout.h
    kernel/wxcursorimage.h
    kernel/wsocket.h
    kernel/wtoplevelsurface.h

    kernel/WOutput
    kernel/WServer
    kernel/WServerInterface
    kernel/WBackend
    kernel/WCursor
    kernel/WInputDevice
    kernel/WSeat
    kernel/WEvent
    kernel/WInputEvent
    kernel/WTexture
    kernel/WSurface

    qtquick/wsurfaceitem.h
    qtquick/WSurfaceItem
    qtquick/woutputhelper.h
    qtquick/woutputlayoutitem.h
    qtquick/wquickoutputlayout.h
    qtquick/woutputrenderwindow.h
    qtquick/woutputviewport.h
    qtquick/woutputitem.h
    qtquick/wquickcursor.h
    qtquick/wquickobserver.h
    qtquick/weventjunkman.h
    qtquick/wrenderhelper.h
    qtquick/wquicktextureproxy.h
    qtquick/woutputlayer.h
    qtquick/wrenderbufferblitter.h
    qtquick/wxdgsurfaceitem.h
    qtquick/wlayersurfaceitem.h
    qtquick/wxwaylandsurfaceitem.h
    qtquick/winputpopupsurfaceitem.h
    qtquick/wqmlcreator.h
    qtquick/wbuffertextureprovider.h

    utils/wtools.h
    utils/wthreadutils.h
    utils/WThreadUtils
    utils/wimagebuffer.h
    utils/wcursorimage.h
    utils/WCursorImage

    protocols/wxdgshell.h
    protocols/WXdgShell
    protocols/wxdgsurface.h
    protocols/WXdgSurface
    protocols/wlayersurface.h
    protocols/wxdgdecorationmanager.h
    protocols/WXdgDecorationManager
    protocols/WLayerSurface
    protocols/wforeigntoplevelv1.h
    protocols/WForeignToplevel
    protocols/wxdgoutput.h
    protocols/WXdgOutput
    protocols/WInputMethodHelper
    protocols/winputmethodhelper.h
    protocols/winputpopupsurface.h
    protocols/WInputPopupSurface
    protocols/wcursorshapemanagerv1.h
    protocols/WCursorShapeManagerV1
    protocols/woutputmanagerv1.h
    protocols/WOutputManagerV1
    protocols/wlayershell.h
    protocols/WLayerShell
    protocols/wxwayland.h
    protocols/WXWayland
    protocols/wxwaylandsurface.h
    protocols/WXWaylandSurface
)

set(PRIVATE_HEADERS
    platformplugin/qwlrootsintegration.h
    platformplugin/qwlrootscreen.h
    platformplugin/qwlrootswindow.h
    platformplugin/qwlrootscursor.h
    platformplugin/types.h
    kernel/private/wglobal_p.h
    kernel/private/wsurface_p.h
    qtquick/private/woutputviewport_p.h
    qtquick/private/wquickcoordmapper_p.h
    qtquick/private/woutputitem_p.h
    qtquick/private/wquicksocketattached_p.h
    qtquick/private/wqmlcreator_p.h
    qtquick/private/wqmlhelper_p.h
    qtquick/private/wquicktextureproxy_p.h
    qtquick/private/wbufferrenderer_p.h
    qtquick/private/wrenderbuffernode_p.h
    qtquick/private/wsurfaceitem_p.h

    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/text-input-unstable-v1-protocol.h
    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/text-input-unstable-v2-protocol.h
    ${WAYLAND_PROTOCOLS_OUTPUTDIR}/xdg-output-unstable-v1-protocol.h

    protocols/private/winputmethodv2_p.h
    protocols/private/wtextinput_p.h
    protocols/private/wtextinputv1_p.h
    protocols/private/wtextinputv2_p.h
    protocols/private/wtextinputv3_p.h
    protocols/private/wvirtualkeyboardv1_p.h
)

if(NOT DISABLE_XWAYLAND)
    list(APPEND SOURCES
        protocols/wxwayland.cpp
        protocols/wxwaylandsurface.cpp
    )

    list(APPEND HEADERS
        protocols/wxwayland.h
        protocols/wxwaylandsurface.h
    )
endif()

add_library(${TARGET}
    SHARED
    ${SOURCES}
)

add_library(Waylib::WaylibServer ALIAS ${TARGET})

qt_add_qml_module(${TARGET}
    URI Waylib.Server
    VERSION "1.0" # Qt bug: The major version must be larger than 0
    OUTPUT_DIRECTORY "Waylib/Server"
    SOURCES
        ${HEADERS}
        ${PRIVATE_HEADERS}
)

target_compile_definitions(${TARGET}
    PRIVATE
    WLR_USE_UNSTABLE
    LIBWAYLIB_SERVER_LIBRARY
    QT_NO_SIGNALS_SLOTS_KEYWORDS
)

set_target_properties(${TARGET}
    PROPERTIES
        VERSION ${CMAKE_PROJECT_VERSION}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME WaylibServer
        PUBLIC_HEADER "${HEADERS}"
	# PRIVATE_HEADER "${PRIVATE_HEADERS}"
	# CMake Warning has PRIVATE_HEADER files but no PRIVATE_HEADER DESTINATION
)

set(QT_LIBRARIES "")
foreach(temp ${QT_COMPONENTS})
    list(APPEND QT_LIBRARIES "Qt6::${temp}")
endforeach()

target_link_libraries(${TARGET}
    PRIVATE
    ${QT_LIBRARIES}
    PkgConfig::WLROOTS
    PkgConfig::LIBDRM
    PkgConfig::WAYLAND
    PkgConfig::WAYLAND_PROTOCOLS
    PkgConfig::PIXMAN
    PkgConfig::XKBCOMMON
    PkgConfig::XCB
    PkgConfig::EGL
)

target_link_libraries(${TARGET}
    PUBLIC
        QWlroots::QWlroots
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

target_include_directories(${TARGET}
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kernel>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/qtquick>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/qtquick/private>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/utils>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/protocols>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/protocols/private>
        $<INSTALL_INTERFACE:${WAYLIB_INCLUDE_INSTALL_DIR}>
    PRIVATE
        ${Qt6Gui_PRIVATE_INCLUDE_DIRS}
        ${Qt6Quick_PRIVATE_INCLUDE_DIRS}
        ${Qt6EglSupport_PRIVATE_INCLUDE_DIRS}
        ${Qt6InputSupport_PRIVATE_INCLUDE_DIRS}
)

target_link_directories(${TARGET}
    INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_LIBDIR}>
)

if (WAYLIB_USE_PERCOMPILE_HEADERS)
    target_precompile_headers(${TARGET}
        PRIVATE
        "$<$<COMPILE_LANGUAGE:CXX>:pch/pch.hxx>"
    )
endif()

install(TARGETS ${TARGET}
    EXPORT
        WaylibServerTargets
    LIBRARY
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER
        COMPONENT Development
        DESTINATION ${WAYLIB_INCLUDE_INSTALL_DIR}
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/../cmake/WaylibServerConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/WaylibServerConfig.cmake"
    INSTALL_DESTINATION ${WAYLIB_CMAKE_INSTALL_DIR}
)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/WaylibServerConfigVersion.cmake"
    VERSION ${DTK_VERSION}
    COMPATIBILITY SameMinorVersion
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/WaylibServerConfig.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/WaylibServerConfigVersion.cmake
    DESTINATION ${WAYLIB_CMAKE_INSTALL_DIR}
)

install(
    EXPORT WaylibServerTargets
    FILE WaylibServerTargets.cmake
    DESTINATION ${WAYLIB_CMAKE_INSTALL_DIR}
    NAMESPACE Waylib::
)

include(${PROJECT_SOURCE_DIR}/cmake/Helpers.cmake)
add_pkgconfig_module(${TARGET} ${TARGET} ${WAYLIB_INCLUDE_INSTALL_DIR}
    "qwlroots, Qt6Gui, Qt6Quick"
)

## waylib 0.2.0-alpha2+git+20240808

=== debian/changelog ===
waylib (0.2.0-alpha2+git+20240808-deepin) unstable; urgency=medium

  * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 08 Aug 2024 10:42:06 +0800

waylib (0.2.0-alpha2+git+20240726-deepin) unstable; urgency=medium

 * Sync upstream code

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 26 Jul 2024 11:00:00 +0800

waylib (0.2.0-alpha2+git+20240626-deepin) unstable; urgency=medium

 * Sync upstream code

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Wed, 26 Jun 2024 18:42:06 +0800

waylib (0.2.0-alpha2) unstable; urgency=medium

   * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@deepin.org>  Thu, 20 Jun 2024 19:00:53 +0800

waylib (0.2.0-alpha1) unstable; urgency=medium

   * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@deepin.org>  Tue, 28 May 2024 13:07:53 +0800

waylib (0.1.1-0deepin) unstable; urgency=medium

  * Exclude client self when request grab keyboard on virtual keyboard.

 -- JiDe Zhang <zhangjide@deepin.org>  Fri, 19 Jan 2023 10:10:03 +0800

waylib (0.0+git20231225-0deepin) UNSTABLE; urgency=medium

  * sync upstream code

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Mon, 25 Dec 2023 13:57:54 +0800

waylib (0.0+git20231208-0deepin) UNSTABLE; urgency=medium

  * fix build with wlroots 0.17.0

 -- rewine <luhongxu@deepin.org>  Fri, 24 Nov 2023 17:28:54 +0800

waylib (0.0+git20231030-0deepin) UNSTABLE; urgency=medium

  * Initial

 -- zkyd <zkyd@zjide.org>  Sat, 17 Jul 2021 16:09:03 +0800

=== debian/control ===
Source: waylib
Section: libdevel
Priority: optional
Maintainer: JiDe Zhang <zhangjide@deepin.org>
Build-Depends: debhelper (>= 9),
 cmake,
 pkg-config,
 qt6-base-private-dev (>= 6.4.0),
 qt6-base-dev-tools (>= 6.4.0),
 qt6-declarative-private-dev (>= 6.4.0),
 qml6-module-qtquick-templates,
 qwlroots,
 libwlroots-dev (>= 0.17.0),
 libpixman-1-dev,
 libxcb-ewmh-dev,
 wayland-protocols,
 wlr-protocols
Standards-Version: 3.9.8

Package: libwaylib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description:  A wrapper for wlroots based on Qt
 .
 This package contains the shared libraries.

Package: libwaylib-dev
Architecture: any
Depends: ${shlibs:Depends},
  ${misc:Depends},
  libwaylib (=${binary:Version}),
  qt6-base-private-dev (>= 6.6.0),
  qt6-base-dev-tools (>= 6.6.0),
  qt6-declarative-private-dev (>= 6.6.0),
  libwlroots-dev (>= 0.17.0),
Description: A devel package for libwaylib
 .
 This package contains the header files and static libraries of waylib.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
export QT_SELECT = qt6

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX=/usr

#override_dh_auto_test:
#	echo "skip auto test"

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

## waylib 0.3.0+git+20241018

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(Waylib
    VERSION 0.1.1
    LANGUAGES CXX C)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(WITH_SUBMODULE_QWLROOTS "Use the QWlroots from git submodule" OFF)
option(BUILD_EXAMPLES "A minimum viable product Wayland compositor based on waylib and other examples" ON)
option(BUILD_TESTS "Build test demos" ON)
option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)
# Don't install tinywl by default, using for debug in local
option(INSTALL_TINYWL "A minimum viable product Wayland compositor based on waylib" OFF)
option(ADDRESS_SANITIZER "Enable address sanitize" OFF)
option(WAYLIB_USE_PERCOMPILE_HEADERS "Use precompile headers to build waylib" ON)

set(QT_COMPONENTS Core Gui Quick)
find_package(Qt6 COMPONENTS ${QT_COMPONENTS} REQUIRED)
if(WITH_SUBMODULE_QWLROOTS)
    include(${CMAKE_CURRENT_SOURCE_DIR}/qwlroots/cmake/WaylandScannerHelpers.cmake)
    add_subdirectory(qwlroots)
    message("Using QWlroots from submodule")
else()
    find_package(QWlroots REQUIRED)
endif()

if(DISABLE_XWAYLAND)
    add_definitions(-DDISABLE_XWAYLAND)
endif()

if (ADDRESS_SANITIZER)
    add_compile_options(-fsanitize=address -fno-optimize-sibling-calls -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()

# For Unix/Linux
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(PackageVersionHelper)

add_subdirectory(src)
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if(BUILD_TESTS)
    add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(manual)
endif()

=== examples/tinywl/CMakeLists.txt ===
find_package(Qt6 COMPONENTS Quick QuickControls2 REQUIRED)
qt_standard_project_setup(REQUIRES 6.4)

if(QT_KNOWN_POLICY_QTP0001) # this policy was introduced in Qt 6.5
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()
if(POLICY CMP0071)
    # https://cmake.org/cmake/help/latest/policy/CMP0071.html
    cmake_policy(SET CMP0071 NEW)
endif()

set(QML_IMPORT_PATH ${CMAKE_BINARY_DIR}/src/server/ CACHE STRING "" FORCE)
option(START_DEMO "Start demo when boot" ON)

find_package(PkgConfig REQUIRED)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)

set(TARGET tinywl-qtquick)

add_executable(${TARGET}
    main.cpp
)

qt_add_qml_module(${TARGET}
    URI Tinywl
    VERSION "2.0"

    SOURCES helper.h helper.cpp
    SOURCES surfacewrapper.h surfacewrapper.cpp
    SOURCES workspace.h workspace.cpp
    SOURCES output.h output.cpp
    SOURCES qmlengine.h qmlengine.cpp
    SOURCES surfacecontainer.h surfacecontainer.cpp
    SOURCES layersurfacecontainer.h layersurfacecontainer.cpp
    SOURCES rootsurfacecontainer.h rootsurfacecontainer.cpp
    SOURCES surfaceproxy.h surfaceproxy.cpp
    SOURCES wallpaperprovider.h wallpaperprovider.cpp
    SOURCES wallpaperimage.h wallpaperimage.cpp
    SOURCES workspacemodel.h workspacemodel.cpp

    QML_FILES PrimaryOutput.qml
    QML_FILES CopyOutput.qml
    QML_FILES TitleBar.qml
    QML_FILES Decoration.qml
    QML_FILES TaskBar.qml
    QML_FILES RoundedClipEffect.qml
    QML_FILES SurfaceContent.qml
    QML_FILES Shadow.qml
    QML_FILES Border.qml
    QML_FILES GeometryAnimation.qml
    QML_FILES OutputMenuBar.qml
    QML_FILES WorkspaceSwitcher.qml
    QML_FILES WorkspaceProxy.qml
    QML_FILES WindowMenu.qml

    RESOURCES
    "res/xx.jpg"
)

target_compile_definitions(${TARGET}
    PRIVATE
    SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
    PROJECT_BINARY_DIR="${PROJECT_BINARY_DIR}"
    $<$<BOOL:${START_DEMO}>:START_DEMO>
)

target_link_libraries(${TARGET}
    PRIVATE
    Qt6::Quick
    Qt6::QuickControls2
    Qt6::QuickPrivate
    Waylib::WaylibServer
    PkgConfig::PIXMAN
    PkgConfig::WAYLAND
)

if (INSTALL_TINYWL)
    install(TARGETS ${TARGET} DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== src/server/CMakeLists.txt ===
--- 
+++ 
@@ -62,7 +62,7 @@
     kernel/wsurface.cpp
     kernel/wtoplevelsurface.cpp
 
-    kernel/wtexture.cpp
+
     kernel/wtypes.cpp
 
     kernel/woutputlayout.cpp
@@ -89,6 +89,8 @@
     qtquick/wxwaylandsurfaceitem.cpp
     qtquick/wqmlcreator.cpp
     qtquick/winputpopupsurfaceitem.cpp
+    qtquick/wsgtextureprovider.cpp
+    qtquick/wtextureproviderprovider.cpp
 
     qtquick/private/wquickcoordmapper.cpp
     qtquick/private/wquicksocketattached.cpp
@@ -143,7 +145,6 @@
     kernel/wevent.h
     kernel/wserver.h
     kernel/wsurface.h
-    kernel/wtexture.h
     kernel/wtypes.h
     kernel/woutputlayout.h
     kernel/wxcursorimage.h
@@ -159,7 +160,6 @@
     kernel/WSeat
     kernel/WEvent
     kernel/WInputEvent
-    kernel/WTexture
     kernel/WSurface
 
     qtquick/wsurfaceitem.h
@@ -182,7 +182,8 @@
     qtquick/wxwaylandsurfaceitem.h
     qtquick/winputpopupsurfaceitem.h
     qtquick/wqmlcreator.h
-    qtquick/wbuffertextureprovider.h
+    qtquick/wsgtextureprovider.h
+    qtquick/wtextureproviderprovider.h
 
     utils/wtools.h
     utils/wthreadutils.h

=== tests/manual/cursor/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(testCursor VERSION 0.1 LANGUAGES CXX)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Widgets)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Widgets)

set(PROJECT_SOURCES
        main.cpp
        widget.cpp
        widget.h
)

if(${QT_VERSION_MAJOR} GREATER_EQUAL 6)
    qt_add_executable(testCursor
        MANUAL_FINALIZATION
        ${PROJECT_SOURCES}
        cursor.qrc
    )
# Define target properties for Android with Qt 6 as:
#    set_property(TARGET cursor APPEND PROPERTY QT_ANDROID_PACKAGE_SOURCE_DIR
#                 ${CMAKE_CURRENT_SOURCE_DIR}/android)
# For more information, see https://doc.qt.io/qt-6/qt-add-executable.html#target-creation
else()
    if(ANDROID)
        add_library(testCursor SHARED
            ${PROJECT_SOURCES}
        )
# Define properties for Android with Qt 5 after find_package() calls as:
#    set(ANDROID_PACKAGE_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/android")
    else()
        add_executable(testCursor
            ${PROJECT_SOURCES}
        )
    endif()
endif()

target_link_libraries(testCursor PRIVATE Qt${QT_VERSION_MAJOR}::Widgets)

# Qt for iOS sets MACOSX_BUNDLE_GUI_IDENTIFIER automatically since Qt 6.1.
# If you are developing for iOS or macOS you should consider setting an
# explicit, fixed bundle identifier manually though.
if(${QT_VERSION} VERSION_LESS 6.1.0)
  set(BUNDLE_ID_OPTION MACOSX_BUNDLE_GUI_IDENTIFIER com.example.cursor)
endif()
set_target_properties(testCursor PROPERTIES
    ${BUNDLE_ID_OPTION}
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

include(GNUInstallDirs)
install(TARGETS testCursor
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

if(QT_VERSION_MAJOR EQUAL 6)
    qt_finalize_executable(testCursor)
endif()

=== tests/manual/subsurface/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(subsurface VERSION 0.1 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt6 REQUIRED COMPONENTS Quick)

qt_standard_project_setup()

if(QT_KNOWN_POLICY_QTP0001) # this policy was introduced in Qt 6.5
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()

qt_add_executable(testSubsurface
    main.cpp
)

qt_add_qml_module(testSubsurface
    URI subsurface
    VERSION 1.0
    QML_FILES Main.qml
    SOURCES window.h
)

# Qt for iOS sets MACOSX_BUNDLE_GUI_IDENTIFIER automatically since Qt 6.1.
# If you are developing for iOS or macOS you should consider setting an
# explicit, fixed bundle identifier manually though.
set_target_properties(testSubsurface PROPERTIES
#    MACOSX_BUNDLE_GUI_IDENTIFIER com.example.testSubsurface
    MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION}
    MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}
    MACOSX_BUNDLE TRUE
    WIN32_EXECUTABLE TRUE
)

target_link_libraries(testSubsurface
    PRIVATE Qt6::Quick
)

include(GNUInstallDirs)
install(TARGETS testSubsurface
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
waylib (0.3.0+git+20241018-0deepin) unstable; urgency=medium

  * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 18 Otc 2024 11:32:00 +0800

waylib (0.3.0-deepin+1) unstable; urgency=medium

  * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 23 Aug 2024 10:01:00 +0800

=== debian/control ===
Source: waylib
Section: libdevel
Priority: optional
Maintainer: JiDe Zhang <zhangjide@deepin.org>
Build-Depends: cmake,
               debhelper (>= 9),
               libpixman-1-dev,
               libwlroots-dev (>= 0.17.0),
               libxcb-ewmh-dev,
               pkg-config,
               qml6-module-qtquick-templates,
               qt6-base-dev-tools (>= 6.4.0),
               qt6-base-private-dev (>= 6.4.0),
               qt6-declarative-private-dev (>= 6.4.0),
               qwlroots,
               wayland-protocols,
               wlr-protocols,
Standards-Version: 3.9.8

Package: libwaylib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description:  A wrapper for wlroots based on Qt
 .
 This package contains the shared libraries.

Package: libwaylib-dev
Architecture: any
Depends: libwaylib (=${binary:Version}),
         libwlroots-dev (>= 0.17.0),
         qt6-base-dev-tools (>= 6.6.0),
         qt6-base-private-dev (>= 6.6.0),
         qt6-declarative-private-dev (>= 6.6.0),
         wlr-protocols,
         ${misc:Depends},
         ${shlibs:Depends},
Description: A devel package for libwaylib
 .
 This package contains the header files and static libraries of waylib.

## waylib 0.3.0+git+20241101

=== debian/changelog ===
waylib (0.3.0+git+20241101-0deepin) unstable; urgency=medium

  * Sync upstream code

  -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 01 Nov 2024 11:32:00 +0800

## waylib 0.6.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.21)
 
 project(Waylib
-    VERSION 0.1.1
+    VERSION 0.6.13
     LANGUAGES CXX C)
 
 set(CMAKE_CXX_STANDARD 20)
@@ -15,7 +15,7 @@
 # Don't install tinywl by default, using for debug in local
 option(INSTALL_TINYWL "A minimum viable product Wayland compositor based on waylib" OFF)
 option(ADDRESS_SANITIZER "Enable address sanitize" OFF)
-option(WAYLIB_USE_PERCOMPILE_HEADERS "Use precompile headers to build waylib" ON)
+option(WAYLIB_USE_PERCOMPILE_HEADERS "Use precompile headers to build waylib" OFF)
 
 set(QT_COMPONENTS Core Gui Quick)
 find_package(Qt6 COMPONENTS ${QT_COMPONENTS} REQUIRED)
@@ -47,5 +47,6 @@
     add_subdirectory(examples)
 endif()
 if(BUILD_TESTS)
+    enable_testing(true)
     add_subdirectory(tests)
 endif()

=== examples/animationclient/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS Quick Widgets)

qt_standard_project_setup(REQUIRES 6.4)

qt_add_executable(animationclient
    main.cpp
)

qt_add_qml_module(animationclient
    URI AnimationClient
    VERSION 1.0
    QML_FILES
        Main.qml
)

target_link_libraries(animationclient
    PRIVATE Qt6::Quick Qt6::Widgets
)

=== qwlroots/examples/CMakeLists.txt ===
include_directories(PRIVATE
    ${PROJECT_SOURCE_DIR}/src
)

add_subdirectory(tinywl)

=== tests/unit_tests/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
add_subdirectory(test_wwrappointer)

=== debian/changelog ===
waylib (0.6.13) unstable; urgency=medium

  * Fix not clear WSurfuce when instantRelease XWaylandSurface

 -- rewine <luhongxu@deepin.org>  Mon, 10 Mar 2025 16:15:50 +0800

waylib (0.6.12) unstable; urgency=medium

  * Fix text-input-v2 popup not update cursorRect before arrange position
  * Fix crash by use WWrapPointer

 -- rewine <luhongxu@deepin.org>  Thu, 20 Feb 2025 19:48:50 +0800

waylib (0.6.11) unstable; urgency=medium

  * bump version to 0.6.11

 -- rewine <luhongxu@deepin.org>  Fri, 14 Feb 2025 10:31:38 +0800

waylib (0.6.10) unstable; urgency=medium

  * bump version to 0.6.10

 -- Groveer <guoyao@uniontech.com>  Wed, 25 Dec 2024 18:45:12 +0800

waylib (0.6.9) unstable; urgency=medium

  * bump version to 0.6.9

 -- Groveer <guoyao@uniontech.com>  Fri, 20 Dec 2024 15:48:51 +0800

waylib (0.6.8) unstable; urgency=medium

  * bump version to 0.6.8

 -- Groveer <guoyao@uniontech.com>  Tue, 17 Dec 2024 21:01:39 +0800

waylib (0.6.7) unstable; urgency=medium

  * bump version to 0.6.7

 -- Groveer <guoyao@uniontech.com>  Fri, 13 Dec 2024 14:08:45 +0800

waylib (0.6.6) unstable; urgency=medium

  * bump version to 0.6.6

 -- Groveer <guoyao@uniontech.com>  Tue, 10 Dec 2024 18:26:33 +0800

waylib (0.6.5) unstable; urgency=medium

  * bump version to 0.6.5

 -- Groveer <guoyao@uniontech.com>  Thu, 05 Dec 2024 21:25:01 +0800

waylib (0.6.4) unstable; urgency=medium

  * bump version to 0.6.4

 -- Groveer <guoyao@uniontech.com>  Sat, 30 Nov 2024 15:21:56 +0800

waylib (0.6.3) unstable; urgency=medium

  * bump version to 0.6.3

 -- Groveer <guoyao@uniontech.com>  Fri, 29 Nov 2024 15:44:40 +0800

waylib (0.6.2) unstable; urgency=medium

  * bump version to 0.6.2

 -- Groveer <guoyao@uniontech.com>  Tue, 26 Nov 2024 18:48:43 +0800

waylib (0.6.1) unstable; urgency=medium

  * bump version to 0.6.1

 -- Groveer <guoyao@uniontech.com>  Fri, 22 Nov 2024 18:06:22 +0800

waylib (0.6.0) unstable; urgency=medium

  * bump version to 0.6.0

 -- Groveer <guoyao@uniontech.com>  Thu, 21 Nov 2024 17:00:46 +0800

waylib (0.5.0) unstable; urgency=medium

  * bump version to 0.5.0

 -- Groveer <guoyao@uniontech.com>  Thu, 14 Nov 2024 03:27:45 +0000

waylib (0.4.3) unstable; urgency=medium

  * bump version to 0.4.3

 -- Groveer <guoyao@uniontech.com>  Thu, 14 Nov 2024 03:26:56 +0000

waylib (0.1.1) UNRELEASED; urgency=medium

  * Exclude client self when request grab keyboard on virtual keyboard.

 -- JiDe Zhang <zhangjide@deepin.org>  Fri, 19 Jan 2023 10:10:03 +0800

waylib (0.0.1) UNRELEASED; urgency=medium

  * Initial

 -- zkyd <zkyd@zjide.org>  Sat, 17 Jul 2021 16:09:03 +0800
